open Format

type linearity = 
     Linear
  |  Nonlinear

type modality = 
    Modal
  | Nonmodal

type aspect = linearity * modality


let leq_lin = function
    (Nonlinear,_) -> true
  | (Linear,Linear) -> true
  | _ -> false

let leq_mod = function
    (Modal,_) -> true
  | (Nonmodal,Nonmodal) -> true
  | _ -> false

let leq_asp = function
    ((l,m),(l',m')) -> leq_lin(l,l') & leq_mod(m,m')

let unknown_aspect = (Nonlinear,Modal)

type t = 
    TVar of string
  | TNat   
  | TArr of aspect * t * t

(*
let safeallowed = function 
    TNat -> true
  | _ -> false

let rec linallowed = function
    TNat -> true
  | TArr(_,TNat,t) -> linallowed t
  | _ -> false
*)
let safeallowed t = true
let linallowed t = true

let banged = function
    TNat -> true
  | _ -> false

let affine = true

let kparen b s = if b then print_string s else ()



let never = 1
let arrow = 2
let app   = 3
let always = 4

let paren context this s = if this<context then print_string s else ()

let rec pr p top = function
  TVar(x) -> print_string x;
| TNat -> print_string "N";
| TArr((l,m),ty1,ty2) -> 
    let symbol = 
        if l=Nonlinear or banged ty1 then "->" else "-o" in
    let prefix = if m = Modal then "$" else "" in
    paren p arrow "(";
    print_string prefix;
    pr app false ty1;
    print_string (if top then " "^symbol^" " else symbol);
    pr arrow top ty2;  paren p arrow ")"

let print_bare ty = pr never true ty

let print ty = 
  print_cut(); print_if_newline(); print_string "  ";
  open_box 2; print_bare ty; close_box(); print_space()









